
VIDEOSEG        EQU     0b800h  
WSTK            EQU     0b8fah    ;b8000h + 4000d

PUBLIC  show_windows,remove_windows
.MODEL  SMALL
.DATA
old_ss  DW      ?
old_sp  DW      ?
wsp     DW      32*1024-4000
bow     DW      ?
.CODE
.286
show_windows PROC    
        pusha 

        mov     al,80           ;calulate the address
        mul     ch              ;ch=row, ax=row*80
        xor     ch,ch           ;cx=cl=col
        add     ax,cx           ;cx=col, ax=row*80+col
        shl     ax,1            ;ax=(row*80+col)*2
        mov     bow,ax          ;Os window W}

        mov     old_sp,sp       ;make new stack
        mov     old_ss,ss       ;save caller's stack
        cli                     
        mov     ax,WSTK         
        mov     ss,ax           ;switch stack
        mov     sp,wsp
        sti                     ;ഫ, sti

        mov     ax,VIDEOSEG
        mov     es,ax
        mov     si,bow          ;es:si Vù}
        mov     cx,[bx]         ;cx = C

 save_loop:
        push    es:[si]         ;push es:si ҫ@ word
        inc     al              
        inc     si        
        inc     si              
        cmp     al,[bx+2]       
        jne     save_loop       
        mov     al,00h    
        sub     si,[bx+2]
        sub     si,[bx+2]
        add     si,160          ;adjust row base to next row
        loop    save_loop

        push    [bx]            ;push row,col to stack
        push    [bx+2]          
        push    bow             ;begin of window

        mov     wsp,sp           ;save sp
        cli
        mov     ax,old_ss       ;restore stack
        mov     ss,ax
        mov     sp,old_sp
        sti

        mov     si,bx           ;screen window
        add     si,6            ;ds:si V Window e
        mov     al,[bx+4]       ;al = ݩ
        mov     di,bow          ;es:di Vù}
        mov     cx,[bx]         ;cx = C

 show_loop: 
        push    cx
        mov     cx,[bx+2]       ;cx = C
 lop1:  movsb                   ;srνX
        stosb                   ;sݩ
        loop    lop1
        sub     di,[bx+2]
        sub     di,[bx+2]
        add     di,160          ;add row base to next row
        pop     cx
        loop    show_loop       ;show next row. . .
        popa
        ret
show_windows ENDP

remove_windows  PROC    

        pusha
        mov     old_sp,sp       ;save old satck ptr
        mov     old_ss,ss
        cli
        mov     ax,WSTK         ;Vsù stack
        mov     ss,ax
        mov     sp,wsp
        sti
        pop     si              ;si = bow
        pop     cx              ;cx = column
        pop     ax              ;ax = row

        mov     dh,al           ;calc address of last cornor
        mov     dl,cl ;dl = column < 255
        dec     ax    
        mov     bl,80
        mul     bl    ;ax = (row - 1)*80
        dec     cx    ;cx = col - 1
        add     ax,cx
        shl     ax,1  ;ax=((row-1)*80+col-1)*2
        add     ax,si ;ax=bow+((row-1)*80+col-1)*2
        mov     si,ax ;si = ax = 1st restore address
        mov     bx,si ;bx as base point for restore

        mov    ax,VIDEOSEG
        mov    es,ax
        mov    al,00h ;al = counter of length
        mov    ch,00h
        mov    cl,dh  ;cx = row length

restore_loop: 
        pop    es:[si]
        inc    al
        dec    si
        dec    si
        cmp    al,dl
        jne    restore_loop
        mov    al,00h
        sub    bx,160
        mov    si,bx
        loop   restore_loop

        mov    wsp,sp    ;restore stack
        cli
        mov    ax,old_ss ; restore stack
        mov    ss,ax
        mov    sp,old_sp
        sti
        popa
        ret
remove_windows  ENDP
              
        END
